import jp.jig.jiglet.*;

public class TrainSearch extends Jiglet {
	String startSta;
	String endSta;
	
	int[] time;
	
	int cursor;
	int subCursor;
	int launchType;
	int defMin = 0;
	
	public void main() {
		if (time == null) {
			setTime();
			cursor = 0;
			subCursor = -1;
		}
		setTitle("抷ē");
		if (startSta == null) {
			readStation();
		}
		launchType = getLaunchType();
		clearKey();
		
		for (;;) {
			setSoftLabel("I");
			
			repaint();
			
			int key = getKey();
			int key2 = 0;
			
			if (subCursor < 0) {
				if (key >= KEY_0 && key <= KEY_9) {
					if (cursor == 3) {
						key2 = key;
						key = KEY_SELECT;
					}
					if (cursor == 5) {
						subCursor = 0;
					}
				}
				if (key == KEY_SELECT) {
					switch (cursor) {
						case 0: {
							String str = inputText(startSta, TEXT_KANA);
							if (str != null) {
								startSta = str;
							}
							break;
						}
						case 1: {
							String dum = endSta;
							endSta = startSta;
							startSta = dum;
							break;
						}
						case 2: {
							String str = inputText(endSta, TEXT_KANA);
							if (str != null) {
								endSta = str;
							}
							break;
						}
						case 3: {
							clearKey();
							key = -1;
							defMin = 0;
							for (;;) {
								repaint();
								sleep(20);
								if (key2 >= KEY_0 && key2 <= KEY_9) {
									defMin = defMin * 10 + (key2 - KEY_0);
									if (defMin >= 999) {
										defMin = 999;
									}
								} else if (key2 >= 0) {
									if (key2 != KEY_SELECT && key2 != KEY_IAPP && key2 != KEY_SOFT) {
										key = key2;
									}
									break;
								}
								key2 = getKey();
							}
							break;
						}
						case 5: {
							subCursor = 0;
							key = -1;
							break;
						}
						case 4:
						case 6:
						case 7: {
							int year = getTime(CALENDAR_YEAR);
							int month = getTime(CALENDAR_MONTH) + 1;
							int date = getTime(CALENDAR_DATE);
							if (cursor == 4) {
								int hour = getTime(CALENDAR_HOUR_OF_DAY);
								int min = getTime(CALENDAR_MINUTE);
								
								min += defMin;
								while (min >= 60) {
									min -= 60;
									hour++;
									if (hour >= 24) {
										hour -= 24;
										date++;
									}
								}
								time[0] = hour / 10;
								time[1] = hour % 10;
								time[2] = min / 10;
								time[3] = min % 10;
							}
							
							
							writeStation();
							StringBuffer sb = new StringBuffer();
							sb.append("http://transit.yahoo.co.jp/search?htmb=select&from=");
							sb.append(encodeURL(startSta));
							
							sb.append("&val_to=");
							sb.append(encodeURL(endSta));
							
							sb.append("&yymm=");
							sb.append(year);
							sb.append(month / 10);
							sb.append(month % 10);
							
							sb.append("&dd=");
							sb.append(date / 10);
							sb.append(date % 10);
							
							if (cursor == 7) {
								sb.append("&kb=ARR");
							} else {
								sb.append("&kb=DEP");
							}
							
							sb.append("&kd=NON&sort=0&num=0&chrg=&air=&hh=");
							sb.append(time[0]);
							sb.append(time[1]);
							
							sb.append("&m1=");
							sb.append(time[2]);
							sb.append("&m2=");
							sb.append(time[3]);
							sb.append("&val_search=+%C3%B5%BA%F7+");
							
							launch(sb.toString(), ENCODE_EUC, 0);
						}
					}
				}
				if (key == KEY_UP && cursor > 0) {
					if (cursor == 2) {
						cursor--;
					}
					cursor--;
				}
				if (key == KEY_DOWN && cursor < 7) {
					if (cursor == 0) {
						cursor++;
					}
					cursor++;
				}
				if (key == KEY_RIGHT && (cursor == 0 || cursor == 2)) {
					cursor = 1;
				}
				if (key == KEY_LEFT && cursor == 1) {
					cursor = 2;
				}
				
				if (key == KEY_IAPP || key == KEY_SOFT) {
					terminate();
				}
			}
			if (subCursor >= 0) {
				if (key == KEY_UP) {
					time[subCursor] = (time[subCursor] + 9) % 10;
				}
				if (key == KEY_DOWN) {
					time[subCursor] = (time[subCursor] + 1) % 10;
				}
				if (key >= KEY_0 && key <= KEY_9) {
					time[subCursor] = (key - KEY_0);
					key = KEY_RIGHT;
				}
				int h = time[0] * 10 + time[1];
				if (h >= 24) {
					time[0] = 2;
					time[1] = 3;
				}
				h = time[2] * 10 + time[3];
				if (h >= 60) {
					time[2] = 5;
					time[3] = 9;
				}
				
				if (key == KEY_RIGHT) {
					subCursor++;
					if (subCursor >= 4) {
						subCursor = -1;
						cursor++;
					}
				}
				if (key == KEY_LEFT) {
					subCursor--;
				}
				if (key == KEY_IAPP || key == KEY_SELECT) {
					subCursor = -1;
				}
			}
			if (key == KEY_SOFT) {
				terminate();
			}
		}
	}
	
	void readStation() {
		byte[] dat = readSP(0, 300);
		int p = 0;
		
		int len = (dat[p++] & 0xFF);
		startSta = new String(dat, p, len);
		p += len;
		
		len = (dat[p++] & 0xFF);
		endSta = new String(dat, p, len);
		p += len;
	}
	void writeStation() {
		byte[] dat = new byte[300];
		int p = 0;
		
		byte[] b = startSta.getBytes();
		dat[p++] = (byte)b.length;
		arraycopy(b, 0, dat, p, b.length);
		p += b.length;
		
		b = endSta.getBytes();
		dat[p++] = (byte)b.length;
		arraycopy(b, 0, dat, p, b.length);
		p += b.length;
		
		writeSP(0, dat);
	}
	void setTime() {
		setTime(currentTime());
		int hour = getTime(CALENDAR_HOUR_OF_DAY);
		int minute = getTime(CALENDAR_MINUTE);
		time = new int[4];
		time[0] = hour / 10;
		time[1] = hour % 10;
		time[2] = minute / 10;
		time[3] = minute % 10;
	}
	
	static int fontH = 12;
	public void paint(boolean allDrawFlag) {
		setFont(0);
		fontH = getFontHeight();
		if (startSta != null) {
			int w = fontH * 12;
			int h = fontH * 8;
			int x = (DW - w) / 2;
			int y = (DH - h) / 2;
			
			setColor(255, 255, 255);
			fillRect(0, 0, DW, DH);
			
			draw3DButton(x, y, w, h);
			x += 3;
			y += 3;
			w -= 6;
			h -= 6;
			
			int sw = fontH * 5 + 6;
			int bx = x + fontH * 2 + 6;
			setColor(0, 0, 0);
			drawString("o:", x, y + fontH);
			drawBox(startSta, bx, y, sw, fontH + 6, cursor == 0, 1);
			
			drawBox("", bx + sw + 10, y + 9, fontH * 2 + 6, fontH + 6, cursor == 1, 0);
			
			y += fontH + 10;
			
			setColor(0, 0, 0);
			drawString(":", x, y + fontH);
			drawBox(endSta, bx, y, sw, fontH + 6, cursor == 2, 1);
			
			bx = x;
			y += fontH + 10;
			
			drawBox("" + defMin, bx, y, fontH * 3, fontH + 6, cursor == 3, 2);
			bx += fontH * 3 + 6;
			drawBox("ɏo", bx, y, fontH * 5 + 6, fontH + 6, cursor == 4, 0);
			
			bx = x;
			y += fontH + 10;
			String str = "" + time[0] + time[1] + ":" + time[2] + time[3];
			drawBox(str, bx, y, fontH * 3, fontH + 6, cursor == 5, 1);
			if (cursor == 5 && subCursor >= 0) {
				int dx = x + (fontH / 2) * subCursor + 3;
				if (subCursor >= 2) {
					dx += fontH / 2;
				}
				setColor(0, 0, 255);
				fillRect(dx, y + 3, fontH / 2, fontH + 1);
				setColor(255, 255, 255);
				drawString("" + time[subCursor], dx, y + 14);
			}
			
			bx += fontH * 3 + 6;
			drawBox("o", bx, y, fontH * 2 + 6, fontH + 6, cursor == 6, 0);
			bx += fontH * 3;
			drawBox("", bx, y, fontH * 2 + 6, fontH + 6, cursor == 7, 0);
			
			bx = x;
			y += fontH + 10;
		}
	}
	
	void drawBox(String str, int x, int y, int w, int h, boolean focus, int type) {
		if (type == 0) {
			draw3DButton(x, y, w, h);
		} else {
			draw3DRect(x, y, w, h);
		}
		if (focus) {
			setColor(255, 0, 0);
			drawRect(x, y, w, h);
			drawRect(x + 1, y + 1, w - 2, h - 2);
		}
		setColor(0, 0, 0);
		int idx = getLineBreak(str, 0, str.length(), w - 6);
		if (type == 2) {
			str = str.substring(0, idx);
			drawString(str, x + w - 3 - stringWidth(str) , y + 14);
		} else {
			drawString(str.substring(0, idx), x + 3, y + 14);
		}
	}
}
